/*****************************************************************************
File: i_getstt.c

Exercise 5: Hook to I$GetStt.

History: Created Jan 20, 1993 by CA
*****************************************************************************/


/*****************************************************************************
Function name: i_getstt

Purpose: hook to I$GetStt, transfer one user parameter (in d2)

Input: i_getstt(int path, int ss_code, int user_parameter)

Output: success/failure

Side effects: may change errno, may change device driver or device status

History: Created Jan 20, 1993 by CA
*****************************************************************************/
int i_getstt(int,int,int);
_asm("i_getstt:");
_asm("  movem.l d1/d2,-(a7)");   /* save registers, d0 and d1 already */
                /* contains correct parameters */
_asm("  movem.l 12(a7),d2");  /* move third parameter to d2 */
_asm("  OS9 I$GetStt");      /* call file manager getstt */
_asm("  bcs.s  i_getstt10");   /* ..error */
_asm("  moveq #0,d0");       /* no error, return 0 */
_asm("  bra.s  i_getstt20");
_asm("i_getstt10");
_asm("  move.l  d1,errno(a6)"); /* save OS-9 error code */
_asm("  moveq #-1,d0");      /* indicate error */
_asm("i_getstt20");
_asm("  movem.l  (a7)+,d1-d2"); /* retrieve registers */
_asm("  rts");
