/* File: calc.c
 *	Calculates expressions of the form + and -
 *
 *
 *
 */
#include <stdio.h>

void parser(char *);
int add(int, int);
int sub(int, int);
void writeerr(char *);
void writeres(int, int, char, int);

int main(void) {
	int x, y, z;
	char errmsg[50], buffer[80];
	char *p = buffer;
	
	printf("Input expression:");
	scanf("%s", buffer); /*string to buffer*/
	parser(buffer);

	return 0;
}


int hexval(char c) {
	char hexdigs[16] = "0123456789ABCDEF";
	int lp1=0;
	
	for (lp1=0;lp1<16;lp1++)
		if (hexdigs[lp1]==c) return lp1;
	return -1;
}

void parser(char *buffer) {
	int lp1=0;
	int a=0, b=0, r=0;
	char op;
	
	/* If first char NAN, error! */
	if (hexval(*buffer)<0) {
		writeerr("Might wanna gimme a number!");
		return;
	}
	/* Scan first hex number */
	while ((lp1<8) && (hexval(*buffer)>=0)) {
		a = a<<4 | hexval(*buffer);
		buffer++; lp1++;
	}
	printf("a = %x\n", a);	

	op = *buffer; buffer++;
	/* find operand */
	if (op!='+' && op!='-') {
		printf("op=%c",op);
		writeerr("Dunno how to calc that");
		return;
	}
	printf("op = %c\n", op);
	
	if (hexval(*buffer)<0) {
		writeerr("Might wanna gimme another number!");
		return;
	}
	/* scan second number */
	while (lp1<8 && hexval(*buffer)>=0) {
		b = b<<4 | hexval(*buffer);
		buffer++; lp1++;
	}	
	printf("b = %x\n", b);

	switch (op) {
		case '+':
			r = add(a,b);
			break;
		case '-':
			r = sub(a,b);
			break;
		default:
			writeerr("C'mon - don't mess with me mind");
			return;
	}
	writeres(a,b,op,r);
	return;
}

void writeres(int a, int b, char op, int r) {
	printf("%d %c %d = %d",a,op,b,r);
	printf("\n");
	return;
}

void writeerr(char *msg) {
	printf(msg);
	printf("\n");
	return;
}
