/* File: floodwrite.c
 * This program tests the device driver by writing as fast as machinably
 * possible to the device and thereby consuming all power...
 *
 */

#include <stdio.h>
#include <process.h>
#include <stdlib.h>
#include <cglob.h>
#include <types.h>
#include <signal.h>
#include "drvinterface.h"


int main(int argc, char* argv[]) {
/*	char buffer[] = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz"; */ /*"DenialOfService - attack - DIE PIG, DIE!!!!!@%&(#%&!@#)*$)!@)_";*/
	char buffer[256], *bufp;
	int sz = sizeof(buffer)-1;
	int lp1, e;
	u_int32 ticks, delay;
	FILE *f;

	if (argc<3) {
		printf("usage: %s <source data file> <transmit-delay>\n Transmits data from input file to port",argv[0]);
		return 1;
	} 
	
	delay = atoi(argv[2]);
	
	f = fopen(argv[1],"rb");
	if (!f) {
		printf("%s: failed opening the file '%s'!\n",argv[0], argv[1]);
		return 2;
	}
	
	
	printf("%s: starting driver...\n",argv[0]);	
	if (e=InitDrv()) {
		printf("%s: error connecting to driver: %i\n",argv[0],e);
		_os_exit(1);
	}
	
	sz=1;
	while (sz) {
		sz = fread(buffer,1,sizeof(buffer),f);
		if (sz>0) { 
			printf("%s: Transmitting data (%i bytes)...\n",argv[0], sz);
			StartBufferWrite(buffer,sz);
			WaitWrite();
			ticks = delay;
			_os9_sleep(&ticks);
		}
	}
	printf("%s: Done transmission, closing driver and exiting...\n",argv[0]);
	
	CloseDrv();
	
	_os_exit(0);
}
